# coding: utf-8

"""
    LocalStack REST API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 4.6.0
    Contact: info@localstack.cloud
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ReplicationConfigSingle(BaseModel):
    """
    Specify the AWS resource to replicate by providing either: (1) the complete `resource_arn`; OR (2) both `resource_type` and `resource_identifier` together. Do not specify both options simultaneously.
    """ # noqa: E501
    resource_arn: Optional[StrictStr] = Field(default=None, description="AWS ARN (Amazon Resource Name) of the resource to replicate. Example: arn:aws:iam::123456789012:role/MyRole")
    resource_type: Optional[StrictStr] = Field(default=None, description="Resource type in AWS CloudControl format. Example: AWS::IAM::Role")
    resource_identifier: Optional[StrictStr] = Field(default=None, description="CloudControl identifier for resource.")
    __properties: ClassVar[List[str]] = ["resource_arn", "resource_type", "resource_identifier"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReplicationConfigSingle from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReplicationConfigSingle from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "resource_arn": obj.get("resource_arn"),
            "resource_type": obj.get("resource_type"),
            "resource_identifier": obj.get("resource_identifier")
        })
        return _obj


